/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Metodos_Ordenacion;

import java.util.ArrayList;
import java.util.List;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JLayeredPane;
import javax.swing.JPanel;

/**
 *
 * @author Usuario iTC
 */
public class Metodo_Quicksort extends javax.swing.JFrame {

    /**
     * Creates new form Metodo_Quicksort
     */
    public Metodo_Quicksort() {
        initComponents();
        setLocationRelativeTo(null);

        setIconImage(new ImageIcon(getClass().getResource("/fotos/icono.jpg")).getImage());//PONER UN ICONO
        ((JPanel) getContentPane()).setOpaque(false);
        ImageIcon uno = new ImageIcon(this.getClass().getResource("/fotos/ci.jpeg"));
        JLabel fondo = new JLabel();
        fondo.setIcon(uno);
        getLayeredPane().add(fondo, JLayeredPane.FRAME_CONTENT_LAYER);
        fondo.setBounds(0, 0, uno.getIconWidth(), uno.getIconHeight());

        setVisible(true);
    }
    long inicio;
    long inicio2;

    int A[];
    String cadena = "";
    Vector arreglo = new Vector();
    int cont = 1;
    List<Integer> lista = new ArrayList<Integer>();
    String presentar;
    String solucion = "";

    boolean pasada1 = true;

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        txtelemento = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        txtvector = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        AREASOLUCION = new javax.swing.JTextArea();
        jLabel6 = new javax.swing.JLabel();
        TXTSOLUCIN = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        lblProceso2 = new javax.swing.JLabel();
        lblProceso = new javax.swing.JLabel();
        TXTNANOSEGUNDOS = new javax.swing.JTextField();
        TXTSEGUNDOS = new javax.swing.JTextField();
        jButton3 = new javax.swing.JButton();
        jLabel7 = new javax.swing.JLabel();
        txtnumeropasadas = new javax.swing.JTextField();
        jButton4 = new javax.swing.JButton();

        jLabel1.setText("jLabel1");

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Metodo Quicksort");

        jLabel2.setFont(new java.awt.Font("Yu Gothic UI Semibold", 0, 18)); // NOI18N
        jLabel2.setText("METODO QUICKSORT ");

        jLabel3.setText("INGRESE ELEMENTO");

        txtelemento.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtelementoActionPerformed(evt);
            }
        });

        jLabel4.setText("DATOS DEL VECTOR");

        txtvector.setEditable(false);

        jLabel5.setText("PROCESO");

        AREASOLUCION.setColumns(20);
        AREASOLUCION.setRows(5);
        jScrollPane1.setViewportView(AREASOLUCION);

        jLabel6.setText("DATOS ORDENADOS");

        jButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fotos/icons8_Cancel_Last_Digit_24px.png"))); // NOI18N
        jButton1.setText("INGRESAR");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fotos/icons8_Bill_24px.png"))); // NOI18N
        jButton2.setText("ORDENAR");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        lblProceso2.setText("Tiempo ( en nanosegundos) ");

        lblProceso.setText("Tiempo ( en segundos) ");

        TXTNANOSEGUNDOS.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                TXTNANOSEGUNDOSActionPerformed(evt);
            }
        });

        jButton3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fotos/icons8_Wipes_24px.png"))); // NOI18N
        jButton3.setText("LIMPIAR");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jLabel7.setText("Numero de Pasadas");

        jButton4.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fotos/icons8_Unavailable_24px.png"))); // NOI18N
        jButton4.setText("SALIR");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3)
                    .addComponent(jLabel4)
                    .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, 117, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel6))
                .addGap(22, 22, 22)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(txtvector, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane1))
                        .addGap(323, 323, 323))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(TXTSOLUCIN, javax.swing.GroupLayout.PREFERRED_SIZE, 310, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(55, 55, 55)
                                .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 115, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButton4))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(txtelemento, javax.swing.GroupLayout.PREFERRED_SIZE, 107, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(209, 209, 209)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jButton1)
                                    .addComponent(lblProceso2, javax.swing.GroupLayout.PREFERRED_SIZE, 246, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(lblProceso)
                                    .addComponent(jLabel7)
                                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                        .addComponent(txtnumeropasadas, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 196, Short.MAX_VALUE)
                                        .addComponent(TXTNANOSEGUNDOS, javax.swing.GroupLayout.Alignment.LEADING))
                                    .addComponent(TXTSEGUNDOS, javax.swing.GroupLayout.PREFERRED_SIZE, 196, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jButton2))))
                        .addContainerGap(17, Short.MAX_VALUE))))
            .addGroup(layout.createSequentialGroup()
                .addGap(268, 268, 268)
                .addComponent(jLabel2)
                .addGap(0, 0, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(64, 64, 64)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(txtelemento, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton1))
                .addGap(22, 22, 22)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(txtvector, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton2))
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(31, 31, 31)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel5)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 158, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel6)
                            .addComponent(TXTSOLUCIN, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(32, 32, 32))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(24, 24, 24)
                        .addComponent(lblProceso2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(TXTNANOSEGUNDOS, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(11, 11, 11)
                        .addComponent(lblProceso)
                        .addGap(18, 18, 18)
                        .addComponent(TXTSEGUNDOS, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel7)
                        .addGap(18, 18, 18)
                        .addComponent(txtnumeropasadas, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jButton3)
                            .addComponent(jButton4))
                        .addContainerGap())))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(375, 375, 375))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // TODO add your handling code here:
        presentar = "";
        cont = 1;
        pasada1 = true;
       
        
        inicio = System.nanoTime();
        inicio2 = System.nanoTime();

        A = new int[cadena.length()];
        System.out.println(cadena);
        System.out.println(cadena.length());
        for (int i = 0; i < cadena.length(); i++) {
            String a = Character.toString(cadena.charAt(i));
            A[i] = Integer.parseInt(a);

        }
        txtvector.setText("" + arreglo);

       
        TXTSOLUCIN.setText(solucion + "");
        txtnumeropasadas.setText(cont + "");
        

        quickShort(A, 0, A.length - 1);
        AREASOLUCION.setText(presentar);
        mostrar(A);

        


    }//GEN-LAST:event_jButton2ActionPerformed
    public void quickShort(int[] arreglo, int inicio, int fin) {

        if (pasada1) {
            presentar = presentar.concat("\n");
            System.out.println("\nPasada 1");
            presentar = presentar.concat("Pasada 1");
        }

        int i = inicio;// i avanza en el arreglo hacia la derecha
        int j = fin;// j avanza en el arreglo hacia la izquierda
        int pivote = arreglo[(inicio + fin) / 2];

        do {
            while (arreglo[i] < pivote) {

                i++; // Si ya esta ordenado incrementa
            }
            while (arreglo[j] > pivote) {

                j--; //Si ya esta ordenado decrementa
            }

            if (i <= j) {

                int aux = arreglo[i];
                arreglo[i] = arreglo[j];
                arreglo[j] = aux;
                i++;
                j--;
            }

            for (int k = 0; k < arreglo.length; k++) {
                int valor = arreglo[k];
                lista.add(valor);
            }
            int cont = 0;
            //
            for (int k = 0; k < lista.size() - 1; k++) {
                if (lista.get(k) <= lista.get(k + 1)) {
                    cont++;
                }
            }
//
            if (lista.size() == arreglo.length) {
                if (cont == lista.size() - 1) {

                    System.out.println(lista);
                    presentar = presentar.concat("\n");
                    presentar = presentar.concat(lista + "");
                    presentar = presentar.concat("\n");
                    cont = 0;
                    return;
                } else {
                    if (cont == 0) {
                        return;
                    } else {
                        presentar = presentar.concat("\n");

                        System.out.println(lista + " holaaaaa");
                        presentar = presentar.concat(lista + "");
                        presentar = presentar.concat("\n");
                        lista.clear();
                    }
                }

            }

        } while (i <= j);

        pasada1 = false;
        this.cont++;
        if (inicio < j) {
            presentar = presentar.concat("Pasada " + (cont));
            presentar = presentar.concat("\n");
            presentar = presentar.concat("______________");
            System.out.println("\nPasada " + cont);
            quickShort(arreglo, inicio, j); //recursividad
            presentar = presentar.concat("\n");

        }
        if (i < fin) {
            presentar = presentar.concat("Pasada " + (cont));
            presentar = presentar.concat("\n");
            presentar = presentar.concat("______________");
            System.out.println("\nPasada " + cont);
            quickShort(arreglo, i, fin);    //recursividad
            presentar = presentar.concat("\n");

        }

    }

    public void mostrar(int[] arreglo) {

        System.out.println("\n\nArreglo ordenado");
        for (int i = 0; i < arreglo.length; i++) {

            System.out.print(arreglo[i] + " ");
            solucion += arreglo[i];

        }
       
         long fin = System.nanoTime();
        long fin2 = System.nanoTime();
        double tiempoEjecucion = (double) (fin - inicio) * 1.0e-9;
        double timeEjecion2 = (double) (fin2 - inicio2);
        TXTNANOSEGUNDOS.setText(timeEjecion2 + "");
        TXTSEGUNDOS.setText(tiempoEjecucion + "");
        System.out.println("El programa durÃ³: " + tiempoEjecucion + " segundos");
        System.out.println("El programa durÃ³: " + timeEjecion2 + " nanometros");
        ///

    }

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        txtelemento.setText(null);
        txtvector.setText(null);
        AREASOLUCION.setText(null);
        TXTNANOSEGUNDOS.setText(null);
        TXTSEGUNDOS.setText(null);
        txtnumeropasadas.setText(null);
        TXTSOLUCIN.setText(null);

        arreglo.clear();
        lista.clear();
        cadena = "";
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // TODO add your handling code here:
        cadena += this.txtelemento.getText();
        ;
        arreglo.add(txtelemento.getText());
        txtvector.setText(arreglo + " ");
        txtelemento.setText("");
        txtelemento.requestFocus();
        System.out.println(cadena);
    }//GEN-LAST:event_jButton1ActionPerformed

    private void TXTNANOSEGUNDOSActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_TXTNANOSEGUNDOSActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_TXTNANOSEGUNDOSActionPerformed

    private void txtelementoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtelementoActionPerformed
        // TODO add your handling code here:

    }//GEN-LAST:event_txtelementoActionPerformed

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        Principal a = new Principal();
        a.setVisible(true);

        hide();
    }//GEN-LAST:event_jButton4ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Metodo_Quicksort.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Metodo_Quicksort.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Metodo_Quicksort.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Metodo_Quicksort.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Metodo_Quicksort().setVisible(true);
            }
        });
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextArea AREASOLUCION;
    private javax.swing.JTextField TXTNANOSEGUNDOS;
    private javax.swing.JTextField TXTSEGUNDOS;
    private javax.swing.JTextField TXTSOLUCIN;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel lblProceso;
    private javax.swing.JLabel lblProceso2;
    private javax.swing.JTextField txtelemento;
    private javax.swing.JTextField txtnumeropasadas;
    private javax.swing.JTextField txtvector;
    // End of variables declaration//GEN-END:variables
}
